SystemOrganization addCategory: #AMP!

WebApplication subclass: #AMPDownloadSongApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMP'!

!AMPDownloadSongApp methodsFor: 'as yet unclassified' stamp: 'SW 11/3/2010 14:10'!
viewMain
	| |
	^WebNonHTMLResource new aidaContentType: 'audio/mpeg'; filename:  self observee fullname
						! !

WebApplication subclass: #AMPMusicPlayerApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMP'!

!AMPMusicPlayerApp class methodsFor: 'as yet unclassified' stamp: 'SW 11/3/2010 10:26'!
register
	| x amp hostname ip siteName styleClass |

	amp _ AMPMusicPlayer new.
	
	hostname:= '*'. 
	ip := '*'.
	styleClass := 'WebStyle'. 
	siteName := 'mysite'.
	(AIDASite named: siteName) isNil ifTrue: [
		x _ AIDASite new name: siteName.
		x  host: hostname ip: ip port: 8000.
		x styleClass: styleClass.	
		SwazooServer singleton addSite: x.
		SwazooServer startSite: siteName.	].		
	(AIDASite named: siteName) urlResolver defaultURL: '/' forObject: amp.
	AIDASite default: siteName.! !

!AMPMusicPlayerApp methodsFor: 'as yet unclassified' stamp: 'SW 11/2/2010 09:51'!
clear! !

!AMPMusicPlayerApp methodsFor: 'as yet unclassified' stamp: 'SW 11/2/2010 12:31'!
clickEventFor:aEntry
|e|
e := WebElement new.
e style: ''.
e addTextBold: 'play'.
Transcript show: 'clickEventFor', aEntry.
^e
! !

!AMPMusicPlayerApp methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 14:28'!
viewMain
	| e rootDir |
	e _ WebElement new.
	e addTextH1: 'Hello World'.
	rootDir := self observee rootDirectory.
	e add: (AMPFolderElement unfoldedFor: rootDir playingOn: self observee).
	e add: (AMPStopButton for: self observee).
	self style pageFrameWith: e title:'blub'.! !

!AMPMusicPlayerApp methodsFor: 'as yet unclassified' stamp: 'SW 11/3/2010 14:07'!
viewSound
	| |
	^WebNonHTMLResource new aidaContentType: 'audio/mpeg'; filename:'E:\HPI\01WhiteWidow.mp3'.
						! !

WebElement subclass: #AMPWebAudioElement
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMP'!

!AMPWebAudioElement methodsFor: 'as yet unclassified' stamp: 'SW 11/3/2010 15:04'!
linkToSource
	^ (AIDASite named:'mysite') urlResolver halfUrlFor: source.! !

!AMPWebAudioElement methodsFor: 'as yet unclassified' stamp: 'SW 11/3/2010 15:04'!
printHTMLPageOn: aStream for: aRequest on: aSession
	source notNil ifTrue: [ aStream nextPutAll: '<audio src="',  self linkToSource , '" controls="controls">Your browser does not support the audio element.</audio>'.]
! !

!AMPWebAudioElement methodsFor: 'as yet unclassified' stamp: 'SW 11/3/2010 14:52'!
source: aSource
	source:=aSource! !

Object subclass: #AMPDownloadSong
	instanceVariableNames: 'fullname'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMP'!

!AMPDownloadSong methodsFor: 'as yet unclassified' stamp: 'SW 11/3/2010 14:10'!
fullname
	^fullname! !

!AMPDownloadSong methodsFor: 'as yet unclassified' stamp: 'SW 11/3/2010 14:10'!
fullname: aFullname
	fullname := aFullname! !

!AMPDownloadSong methodsFor: 'as yet unclassified' stamp: 'SW 11/3/2010 15:34'!
preferedUrl
        ^'/songs/', self fullname onlyLetters , '.ogg'
! !

Object subclass: #AMPMusicPlayer
	instanceVariableNames: 'rootDirectory player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMP'!

!AMPMusicPlayer class methodsFor: 'as yet unclassified' stamp: 'SW 11/3/2010 15:30'!
defaultPath
	^'E:\HPI\BachelorProjekt\Songs\'! !

!AMPMusicPlayer methodsFor: 'as yet unclassified' stamp: 'SW 11/2/2010 10:59'!
initialize
	rootDirectory := FileDirectory forFileName:AMPMusicPlayer defaultPath.
	
	"AMPDirectory new for: AMPMusicPlayer defaultPath.
	rootDirectory openDirectory."! !

!AMPMusicPlayer methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 12:17'!
playSong: aFile
	self player stopPlaying.
	self player openFileNamed: aFile fullName.
	self player startPlaying.
! !

!AMPMusicPlayer methodsFor: 'as yet unclassified' stamp: 'SW 11/1/2010 18:07'!
player
	player ifNil: [player:=MPEGDisplayMorph new].
	^player! !

!AMPMusicPlayer methodsFor: 'as yet unclassified' stamp: 'SW 11/2/2010 10:30'!
rootDirectory 
	^rootDirectory
! !

!AMPMusicPlayer methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 12:38'!
stopSong

	self player stopPlaying.
	! !

WebWidget subclass: #AMPFileElement
	instanceVariableNames: 'file stream player song'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMP'!

!AMPFileElement class methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 13:55'!
for: aFile playingOn: anAMPMusicPlayer
	
	| new |
	new := self new file: aFile.
	new player: anAMPMusicPlayer.
	^new! !

!AMPFileElement class methodsFor: 'as yet unclassified' stamp: 'SW 11/3/2010 11:24'!
new
	^ super new method: #ajaxStarter:.
! !

!AMPFileElement methodsFor: 'as yet unclassified' stamp: 'SW 11/3/2010 14:40'!
ajaxStarter: aString

	(aString = 'remote') 
		ifTrue: [
			Transcript show: 'play: ', self file name; cr.
			self player playSong: self file.
			self stream: false]
		ifFalse: [
			song := AMPDownloadSong new.
			song fullname: self file fullName.
			
			Transcript show: 'stream: ', self file name; cr.
			self stream: true]
		! !

!AMPFileElement methodsFor: 'accessing' stamp: 'SW 11/3/2010 11:43'!
file
	^file! !

!AMPFileElement methodsFor: 'accessing' stamp: 'lw 11/3/2010 13:57'!
file:aFile
	file:= aFile! !

!AMPFileElement methodsFor: 'accessing' stamp: 'lw 11/3/2010 14:13'!
initialize

	super initialize.
	self stream: false.! !

!AMPFileElement methodsFor: 'accessing' stamp: 'lw 11/3/2010 13:16'!
player
	^player! !

!AMPFileElement methodsFor: 'accessing' stamp: 'lw 11/3/2010 13:16'!
player: anAMPMusicPlayer
	player:=anAMPMusicPlayer! !

!AMPFileElement methodsFor: 'as yet unclassified' stamp: 'SW 11/3/2010 15:06'!
prepareToHTMLPrintOn: aSession

	| x |
	self initElements.
	self addText: self file name.
	self addSpace.
	(self addNilLinkText: 'play remote')
		onClickUpdate: self with: #remote.
	self addSpace.
	self stream 
		ifTrue: [		
			x_ AMPWebAudioElement new source:song.	
			self add: x.
"			self addLinkTo: song text:'download'."
			]
		ifFalse: [
			(self addNilLinkText: 'stream')
				onClickUpdate: self with: #stream]! !

!AMPFileElement methodsFor: 'accessing' stamp: 'lw 11/3/2010 14:10'!
stream
	^stream! !

!AMPFileElement methodsFor: 'accessing' stamp: 'lw 11/3/2010 14:10'!
stream: aBoolean
	stream := aBoolean! !

WebWidget subclass: #AMPFolderElement
	instanceVariableNames: 'folder player folded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMP'!

!AMPFolderElement class methodsFor: 'instance creation' stamp: 'lw 11/3/2010 13:13'!
for: aFolder playingOn: anAMPMusicPlayer
	
	| new |
	new := self new folder: aFolder.
	new player: anAMPMusicPlayer.
	^new! !

!AMPFolderElement class methodsFor: 'instance creation' stamp: 'lw 11/3/2010 13:40'!
new
	^ super new method: #ajaxStarter.
! !

!AMPFolderElement class methodsFor: 'instance creation' stamp: 'lw 11/3/2010 14:23'!
unfoldedFor: aFolder playingOn: anAMPMusicPlayer
	
	| new |
	new := self new folder: aFolder.
	new player: anAMPMusicPlayer.
	new folded: false.
	^new! !

!AMPFolderElement methodsFor: 'events-ajax' stamp: 'lw 11/3/2010 14:24'!
ajaxStarter
	
	self folded: self folded not! !

!AMPFolderElement methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 14:25'!
displayFolded
	
	self initElements.
	(self addNilLinkText: '+ ')
		onClickUpdate: self.
	self addText: self folder localName.! !

!AMPFolderElement methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 14:25'!
displayUnfolded
	| content |
	self initElements.
	(self addNilLinkText: '- ')
		onClickUpdate: self.
	self addText: self folder localName.
	content := self add: WebElement new setDiv.
	(self folder entries select: [:entry | entry isDirectory ]) 
		do: [:entry |	
				content add: (AMPFolderElement for: entry asFileDirectory playingOn: self player)].
	(self folder entries select: [:entry | entry isDirectory not ]) 
		do: [:entry | 	
			content add: (AMPFileElement for: entry playingOn: self player)] ! !

!AMPFolderElement methodsFor: 'accessing' stamp: 'lw 11/3/2010 14:25'!
folded
	^folded! !

!AMPFolderElement methodsFor: 'accessing' stamp: 'lw 11/3/2010 14:25'!
folded: aBoolean
	folded := aBoolean! !

!AMPFolderElement methodsFor: 'accessing' stamp: 'lw 11/3/2010 12:59'!
folder
	^folder! !

!AMPFolderElement methodsFor: 'accessing' stamp: 'lw 11/3/2010 14:24'!
folder: aFolder
	folder:= aFolder! !

!AMPFolderElement methodsFor: 'initialization' stamp: 'lw 11/3/2010 14:26'!
initialize

	super initialize.
	self folded: true.! !

!AMPFolderElement methodsFor: 'accessing' stamp: 'lw 11/3/2010 12:59'!
player
	^player! !

!AMPFolderElement methodsFor: 'accessing' stamp: 'lw 11/3/2010 12:57'!
player: aMusicPlayer
	player:=aMusicPlayer! !

!AMPFolderElement methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 14:27'!
prepareToHTMLPrintOn: aSession

	self folded 
		ifTrue: [ self displayFolded ]
		ifFalse: [ self displayUnfolded ]! !

WebWidget subclass: #AMPStopButton
	instanceVariableNames: 'player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMP'!

!AMPStopButton class methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 12:32'!
for: aPlayer

	^self new player: aPlayer! !

!AMPStopButton class methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 12:40'!
new

	^super new method: #ajaxStopPlayback! !

!AMPStopButton methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 12:44'!
ajaxStopPlayback

	self player stopSong! !

!AMPStopButton methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 12:44'!
initialize
	
	self method: #ajaxStopPlayback.
	(self addNilLinkText: 'stop')
		onClickUpdate: self! !

!AMPStopButton methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 12:25'!
player

	^player! !

!AMPStopButton methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 12:24'!
player: aPlayer

	player := aPlayer! !
